<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">

    <ui:param name="pageNameTitle" value="#{messages['gazelle.common.menu.TestingSessionScope']}"/>
    <ui:param name="containerStyle" value="gzl-container-fluid"/>
    <ui:define name="body">
        <h:form id="reportsFormId">
            <s:token allowMultiplePosts="true"/>
            <h:commandButton id="testingSessionScopeId"
                             value="#{messages['net.ihe.gazelle.TestingSessionScopeExport.ExportScope']}"
                             action="#{testingSessionScopeBeanGui.getTestingSessionScope()}" styleClass="gzl-btn"
                             rendered="true"/>
        </h:form>

        <h:form id="searchCriteriaForm" styleClass="form-horizontal">
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{testingSessionScopeBeanGui.filter.urlParameters}"/>
            <script>
                updateUrl("searchCriteriaForm:filterUrlParameters");
                $("#searchCriteriaForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("searchCriteriaForm:filterUrlParameters");
                    });
            </script>
            <div class="row search-criteria">
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testingSessionScopeBeanGui.getFilter()}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="domain"/>
                        <ui:param name="filterName" value="#{messages['gazelle.tf.Domain']}"/>
                        <ui:param name="filterForm" value="searchCriteriaForm,resultsForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testingSessionScopeBeanGui.getFilter()}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="integrationProfile"/>
                        <ui:param name="filterName" value="#{messages['gazelle.testmanagement.object.Profile']}"/>
                        <ui:param name="filterForm" value="searchCriteriaForm,resultsForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <ui:include src="/filter/filterLabelInside.xhtml">
                        <ui:param name="filter" value="#{testingSessionScopeBeanGui.getFilter()}"/>
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filterId" value="testability"/>
                        <ui:param name="filterName" value="#{messages['gazelle.productregistry.crawler.Status']}"/>
                        <ui:param name="filterForm" value="searchCriteriaForm,resultsForm"/>
                    </ui:include>
                </div>
                <div class="col-lg-3">
                    <h4>
                        <a4j:commandLink actionListener="#{testingSessionScopeBeanGui.clearFilter()}"
                                         title="#{messages['net.ihe.gazelle.tm.Reset']}"
                                         render="searchCriteriaForm,resultsForm">
                            <span class="gzl-icon-stack">
                                <span class="fa-xl gzl-icon-filter gzl-icon-stack-1x"/>
                                <span class="gzl-icon-times gzl-icon-stack-1x gzl-icon-stack-bottom-right"/>
                            </span>
                        </a4j:commandLink>
                        <a4j:commandLink actionListener="#{testingSessionScopeBeanGui.refreshPage()}"
                                         title="#{messages['gazelle.common.button.Refresh']}"
                                         render="searchCriteriaForm,resultsForm">
                            <span class="fa-xl gzl-icon-refresh"/>
                        </a4j:commandLink>


                        <a4j:commandLink id="currentSystemSummary_DeleteSupport"
                                         value="#{messages['net.ihe.gazelle.tm.EvaluateSystems']}"
                                         immediate="true"
                                         title="#{messages['net.ihe.gazelle.tm.EvaluateSystems']}"
                                         styleClass="gzl-btn-green"
                                         onclick="jq162('#evaluateSystem').modal('show');"
                                         rendered="#{testingSessionScopeBeanGui.isAdminOrTSM()}">

                        </a4j:commandLink>


                    </h4>
                </div>
            </div>
            <div class="col-lg-7">
            </div>
            <label class="control-label col-lg-1">
                #{messages['net.ihe.gazelle.tm.SortBy']}
            </label>
            <div class="col-lg-2">
                <h:selectOneMenu styleClass="form-control gzl-select-text"
                                 id="sortMethod"
                                 value="#{testingSessionScopeBeanGui.selectedSort}">
                    <s:selectItems
                            value="#{testingSessionScopeBeanGui.getAllSortMethods()}"
                            var="sortUsed"
                            label="#{messages[sortUsed.getLabelToDisplay()]}"/>
                    <a4j:ajax event="change" execute="@this"
                              render="searchCriteriaForm,resultsForm"/>
                </h:selectOneMenu>
            </div>
            <div class="col-lg-2">
                <button type="button" class="gzl-btn-blue gzl-sut-report-button pull-right" onclick="collapseAll()">
                    #{messages['net.ihe.gazelle.tm.CollapseAll']}
                </button>
                <button type="button" class="gzl-btn-blue gzl-sut-report-button pull-right" onclick="expandAll()">
                    #{messages['net.ihe.gazelle.tm.ExpandAll']}
                </button>
            </div>
        </h:form>


        <h:form id="evaluateSystemForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="evaluateSystem"/>
                <ui:param name="bodyStyleClass" value="modal-body"/>
                <ui:param name="styleClass2" value="gzl-change-session-model modal-xl modal-body"/>
                <ui:define name="popup_title">#{messages['net.ihe.gazelle.tm.EvaluationStatus']}</ui:define>
                <p>#{messages['net.ihe.gazelle.tm.EvaluateSystemsForThisTestingSessionChooseTheEva']}</p>
                <div class="col-md-6">
                    <p>#{messages['net.ihe.gazelle.tm.SelectTestability']}</p>
                    <h:selectOneMenu id="testabilityEvaluation"
                                     styleClass="form-control gzl-select-text"
                                     value="#{testingSessionScopeBeanGui.selectedTestability}">
                        <s:selectItems value="#{testingSessionScopeBeanGui.getDroppedAndRemoveTestability()}"
                                       var="selectedTestability"
                                       label="#{messages[selectedTestability.labelToDisplay]}"/>
                    </h:selectOneMenu>

                </div>
                <div class="col-md-6">
                    <p>#{messages['net.ihe.gazelle.tm.SelectEvaluationStatus']}</p>
                    <h:selectOneMenu id="status"
                                     styleClass="form-control gzl-select-text"
                                     style="width: 90%;display: initial;"
                                     value="#{testingSessionScopeBeanGui.selectedStatus}">
                        <s:selectItems value="#{testingSessionScopeBeanGui.getStatus()}"
                                       var="selectedStatus"
                                       label="#{messages[selectedStatus.labelToDisplay]}"/>
                    </h:selectOneMenu>
                </div>

                <ui:define name="popup_footer">
                    <a class="col-md-12">
                        <button type="button" class="gzl-btn" data-dismiss="modal">
                            #{messages['gazelle.tm.Cancel']}
                        </button>
                        <a4j:commandButton id="acceptConfirmationPanelButton" styleClass="gzl-btn-green"
                                           ignoreDupResponses="true"
                                           value="#{messages['net.ihe.gazelle.tm.Autoevaluate']}"
                                           actionListener="#{testingSessionScopeBeanGui.autoEvaluate()}"
                                           onclick="jq162('#evaluateSystem').modal('hide');"
                                           data-dismiss="modal"
                                           execute="status, testabilityEvaluation"/>
                    </a>
                </ui:define>

            </ui:decorate>
        </h:form>
        <h:form id="resultsForm">
            <rich:dataGrid id="profileScopeGrid"
                           value="#{testingSessionScopeBeanGui.getProfileScopes()}"
                           var="profileScope" render="profileScopeGridDs"
                           elements="#{dataScrollerMemory.numberOfResultsPerPage}"
                           style="width:100%">
                <div class="row gzl-sut-report panel panel-default">
                    <div class="gzl-sut-report-panel-heading" style="border-color: transparent">
                        <div class="row panel-title">
                            <div class="col-md-5">
                                <h3>
                                    #{profileScope.profileInTestingSession.integrationProfile.keyword} -
                                    #{profileScope.profileInTestingSession.integrationProfile.name}
                                    (#{profileScope.profileInTestingSession.domain.name})
                                </h3>
                            </div>

                            <s:div rendered="#{testingSessionScopeBeanGui.isAdminOrTSM()}">
                                <ui:include src="/reports/resultFormAdmin.xhtml"/>
                            </s:div>
                            <s:div rendered="#{!testingSessionScopeBeanGui.isAdminOrTSM()}">
                                <ui:include src="/reports/resultFormNonAdmin.xhtml"/>
                            </s:div>


                        </div>
                    </div>
                    <div id="profile#{profileScope.profileInTestingSession.id}" class="panel-collapse collapse"
                         aria-expanded="false">
                        <ui:repeat value="#{testingSessionScopeBeanGui.getProfileCoveragesByProfileScope(profileScope)}"
                                   var="profileCoverage">
                            <div>
                                <div class="row">
                                    <h3>
                                        <h:outputText class="actor-coverage-style"
                                                      value="#{profileCoverage.actorName}"/>
                                        <h:outputText class="gzl-label gzl-label-blue actor-coverage-style actor-coverage-number-sut-style"
                                                      value="#{profileCoverage.implementedActorInSystems.size()} #{messages['net.ihe.gazelle.tm.SUTs']}"/>

                                    </h3>

                                </div>
                                <div class="actor-coverage-style">
                                    <rich:dataTable value="#{profileCoverage.implementedActorInSystems}"
                                                    var="implementedActorInSystem"
                                                    rendered="#{!profileCoverage.implementedActorInSystems.isEmpty()}">
                                        <g:column style="width:30%">
                                            <ui:define name="header">
                                                <h:outputText id="institutionName"
                                                              value="#{messages['gazelle.users.institution.InstitutionName']}"/>
                                            </ui:define>
                                            <h:outputText value="#{implementedActorInSystem.organizationName}"/>
                                        </g:column>
                                        <g:column style="width:30%">
                                            <ui:define name="header">
                                                <h:outputText id="systemKeyword"
                                                              value="#{messages['gazelle.systems.system.SystemKeyword']}"/>
                                            </ui:define>
                                            <h:outputText value="#{implementedActorInSystem.systemKeyword}"/>
                                        </g:column>
                                        <g:column rendered="#{testingSessionScopeBeanGui.isAdminOrTSM()}"
                                                  style="width:10%">
                                            <ui:define name="header">
                                                <h:outputText id="registrationStatus"
                                                              value="#{messages['net.ihe.gazelle.tm.RegistrationStatus']}"/>
                                            </ui:define>
                                            <h:outputText
                                                    class="#{implementedActorInSystem.registrationStatus.getCssStyle()}"
                                                    value="#{messages[implementedActorInSystem.registrationStatus.getLabelToDisplay()]}"/>
                                        </g:column>
                                        <g:column rendered="#{testingSessionScopeBeanGui.isAdminOrTSM()}"
                                                  style="width:10%">
                                            <ui:define name="header">
                                                <h:outputText id="accepted"
                                                              value="#{messages['gazelle.tm.Accepted']} ?"/>
                                            </ui:define>
                                            <s:span rendered="#{implementedActorInSystem.acceptedToSession}">
                                                <span class="fa gzl-icon-checked"/>
                                                <h:outputText value="#{messages['gazelle.common.Yes']}"/>
                                            </s:span>
                                            <s:span rendered="#{!implementedActorInSystem.acceptedToSession}">
                                                <span class="fa gzl-icon-waiting-orange"/>
                                                <h:outputText value="#{messages['gazelle.common.No']}"/>
                                            </s:span>
                                        </g:column>
                                        <g:column style="width:20%">
                                            <ui:define name="header">
                                                <h:outputText id="profileOptions"
                                                              value="#{messages['net.ihe.gazelle.tm.ProfileOptions']}"/>
                                            </ui:define>
                                            <ui:repeat value="#{implementedActorInSystem.profileOptions}"
                                                       var="profileOption">
                                                <h:outputText value="#{profileOption}"/>
                                                <br/>
                                            </ui:repeat>
                                        </g:column>
                                    </rich:dataTable>
                                    <s:div styleClass="gzl-alert gzl-alert-orange"
                                           rendered="#{profileCoverage.implementedActorInSystems.isEmpty()}">
                                        #{messages['net.ihe.gazelle.tm.NoSystemForThisActor']}
                                    </s:div>
                                </div>
                            </div>
                        </ui:repeat>
                    </div>
                </div>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="profileScopeGridDs"/>
                        <ui:param name="dataTableId" value="profileScopeGrid"/>
                        <ui:param name="maxPages" value="10"/>
                    </ui:include>
                </f:facet>
            </rich:dataGrid>
            <script>
                function expandCollapseIcon(className) {
                    let icon = document.getElementsByClassName("profile" + className).item(0);
                    icon.classList.toggle("gzl-icon-collapse");
                    icon.classList.toggle("gzl-icon-expand");
                }
            </script>
            <script>
                function collapseAll() {
                    let icons = Array.prototype.slice.call(document.getElementsByClassName("changeIcon"));
                    icons.forEach(icon => {
                        icon.classList.remove("gzl-icon-collapse");
                        icon.classList.add("gzl-icon-expand");
                    })
                    jq162('.panel-collapse.in').collapse('hide');
                }
            </script>
            <script>
                function expandAll() {
                    let icons = Array.prototype.slice.call(document.getElementsByClassName("changeIcon"));
                    icons.forEach(icon => {
                        icon.classList.remove("gzl-icon-expand");
                        icon.classList.add("gzl-icon-collapse");
                    })
                    jq162('.panel-collapse:not(".in")').collapse('show');
                }
            </script>
        </h:form>
    </ui:define>
</ui:composition>